import jp.ac.takushoku_u.cs.*;

/**
* LFTAnalysis饹Υƥѥ饹
* @version 1.3
* @author  ͵(Kasajima Hiroshi)
*/
/*
* ǽ 2005ǯ0108
*/
class LFTAnalysisTest{

public static void main(String[] args){

	boolean[][] sampleData = { //ԤΥޥȥꥯǡ
		    {false,false,false,false,false,false,false,false,false},
			{true,false,false,false,false,false,false,false,false},
			{true,false,false,false,false,false,false,false,false},
			{true,false,false,false,false,false,false,false,false},
			{false,true,true,true,false,false,false,false,false},
			{false,false,false,false,true,false,false,false,false},
			{false,false,false,false,false,true,false,false,false},
			{false,false,false,false,false,true,false,false,false},
			{false,false,false,false,false,true,true,true,false}};
	
		boolean[][] sampleData2 = { //ؽԤΥޥȥꥯǡ Ԥ(7,6)ʤ
		    {false,false,false,false,false,false,false,false,false},
			{true,false,false,false,false,false,false,false,false},
			{true,false,false,false,false,false,false,false,false},
			{true,false,false,false,false,false,false,false,false},
			{false,true,true,true,false,false,false,false,false},
			{false,false,false,false,true,false,false,false,false},
			{false,false,false,false,false,false,false,false,false},
			{false,false,false,false,false,true,false,false,false},
			{false,false,false,false,false,true,true,true,false}};
	
	String[] name = {"1","2","3","4","5","6","7","8","9"};
	
	//ޥȥꥯ
	BooleanMatrix dataMatrix = new BooleanMatrix(sampleData, name, name);
	BooleanMatrix dataMatrix2 = new BooleanMatrix(sampleData2, name, name);
	
	//LFTʬϤԤ
	LFTAnalysis result = new LFTAnalysis(dataMatrix, dataMatrix2);
	
	//ԤΥޥȥꥯϤ
	BooleanMatrix outTeacherMatrix = new BooleanMatrix(5,5);
	//ԤΥޥȥꥯμ
	outTeacherMatrix.matrixCopy(result.getTeacherMatrix());
	System.out.println("ԤΥޥȥꥯ");
	//ޥȥꥯν
	outputMatrix(outTeacherMatrix);
	
	//ԤΥޥȥꥯȳؽԤΥޥȥꥯ1ĤˤϤ
	StringMatrix outBlendStringMatrix = new StringMatrix(9,9);
	outBlendStringMatrix.matrixCopy(result.getBlendStringMatrix());
	System.out.println("ԤΥޥȥꥯȳؽԤΥޥȥꥯɽޥȥꥯ");
	System.out.println("ξԤʤ = 0, ξԤ = 1, ԤΤ = T, ؽԤΤ = S");
	outputMatrix(outBlendStringMatrix);
	
	//ԤΥޥȥꥯˤޤν٤Ϥ
	ArithmeticMatrix outEdgeMatrix = new ArithmeticMatrix(9,9);
	outEdgeMatrix.matrixCopy(result.getEdgeTeacherMatrix());
	System.out.println("Ԥλޤν٤ɽޥȥꥯ");
	outputDoubleMatrix(outEdgeMatrix);
	
	//ԤβãޥȥꥯϤ
	BooleanMatrix outReachMatrix = new BooleanMatrix(9,9);
	outReachMatrix.matrixCopy(result.getReachTeacherMatrix());
	System.out.println("Ԥβãޥȥꥯ");
	outputMatrix(outReachMatrix);
	
	//ԥޥȥꥯ(6,5)нϤ
	BooleanMatrix outPairMatrix = new BooleanMatrix(9,9);
	outPairMatrix.matrixCopy(result.getElementPairMatrix(dataMatrix, 
		dataMatrix.getRowNumber("6"), dataMatrix.getColNumber("5")));
	System.out.println("ԤΥޥȥꥯˤơ(6,5)нޥȥꥯ");
	outputMatrix(outPairMatrix);
	
	System.out.println("Фǿ = " + outPairMatrix.getElement());
	System.out.println();
	
	//׻ǵ줿
	System.out.println("= " + result.getResemble());
	System.out.println("ã= " + result.getAttainment());
	System.out.println("Ԥλ= " + result.getTeacherEdge());
	System.out.println("ؽԤλ= " + result.getStudentEdge());
	System.out.println("׻= " + result.getAccordEdge());
	System.out.println("ˤǤ⤢= " + result.getTotelEdge());
	System.out.println("ؽԤΤߤλ= " + result.getStudentOnlyEdge());
	System.out.println("ԤΤߤλ= " + result.getTeacherOnlyEdge());
}
	
/**
* ޥȥꥯintɸϤ˽Ϥޤ
* @param outMatrix Ϥ٤ޥȥꥯ
*/
	private static void outputMatrix(ArithmeticMatrix outMatrix){
		System.out.print("       ");
		for(int j = 0; j < outMatrix.getColLength(); j++){		//̾
			System.out.print(outMatrix.getColName(j) + " ");
		}
		System.out.println();
		for(int i = 0 ; i < outMatrix.getRowLength(); i++){
			if(i < 9){
			System.out.print(outMatrix.getRowName(i) + " ");		//̾
			}
			else{
				System.out.print(outMatrix.getRowName(i) + " ");
			}
			for(int j = 0; j < outMatrix.getColLength(); j++){		//ǽ
				if(j == (outMatrix.getColLength() - 1)){
					System.out.println("     "+(int)outMatrix.getCell(i, j));
				}
				else{
					System.out.print("     "+(int)outMatrix.getCell(i, j));
				}
			}
		}
		System.out.println();
	}
	
/**
* ޥȥꥯdoubleɸϤ˽Ϥޤ
* @param outMatrix Ϥ٤ޥȥꥯ
*/
	private static void outputDoubleMatrix(ArithmeticMatrix outMatrix){
		java.text.NumberFormat df = new java.text.DecimalFormat("0.000");		//ʲ3ޤǽ
		System.out.print("       ");
		for(int j = 0; j < outMatrix.getColLength(); j++){
			System.out.print(outMatrix.getColName(j) + " ");		//̾
		}
		System.out.println();
		for(int i = 0 ; i < outMatrix.getRowLength(); i++){
			System.out.print(outMatrix.getRowName(i) + "  ");		//̾
			for(int j = 0; j < outMatrix.getColLength(); j++){		//ǽ
				if(j == (outMatrix.getColLength() - 1)){
					System.out.println(df.format(outMatrix.getCell(i, j)));
				}
				else{
					System.out.print(df.format(outMatrix.getCell(i, j) )+" ");
				}
			}
		}
		System.out.println();
	}
	
/**
* ޥȥꥯbooleanɸϤ˽Ϥޤ
*/
	private static void outputMatrix(BooleanMatrix outMatrix){
		System.out.print("       ");
		for(int j = 0; j < outMatrix.getColLength(); j++){		//̾
			System.out.print(outMatrix.getColName(j) + " ");
		}
		System.out.println();
		for(int i = 0 ; i < outMatrix.getRowLength(); i++){
			if(i < 9){
			System.out.print(outMatrix.getRowName(i) + " ");		//̾
			}
			else{
				System.out.print(outMatrix.getRowName(i) + " ");
			}
			for(int j = 0; j < outMatrix.getColLength(); j++){		//ǽ
				if(j == (outMatrix.getColLength() - 1)){
					System.out.println(" "+outMatrix.getCell(i, j));
				}
				else{
					System.out.print(" "+outMatrix.getCell(i, j));
					if(outMatrix.getCell(i, j)){
						System.out.print(" ");
					}
				}
			}
		}
		System.out.println();
	}
	
/**
* StringMatrixɸϤ˽Ϥޤ
* @param outMatrix Ϥ٤ޥȥꥯ
*/
	private static void outputMatrix(StringMatrix outMatrix){
		System.out.print("       ");
		for(int j = 0; j < outMatrix.getColLength(); j++){		//̾
			System.out.print(outMatrix.getColName(j) + " ");
		}
		System.out.println();
		for(int i = 0 ; i < outMatrix.getRowLength(); i++){
			if(i < 9){
			System.out.print(outMatrix.getRowName(i) + " ");		//̾
			}
			else{
				System.out.print(outMatrix.getRowName(i) + " ");
			}
			for(int j = 0; j < outMatrix.getColLength(); j++){		//ǽ
				if(j == (outMatrix.getColLength() - 1)){
					System.out.println("     "+outMatrix.getCell(i, j));
				}
				else{
					System.out.print("     "+outMatrix.getCell(i, j));
				}
			}
		}
		System.out.println();
	}
}
